/**
 * @file
 * Author: Synpase-studio.
 */

(function ($) {
  $(document).ready(function () {
    ymaps.ready(ymapsInit);

    function ymapsInit() {
      var pos = '<div class="ymap">' +
        '<div id="map" style="min-height:100px"></div>' +
        '<div class="shadow_t"></div> <div class="shadow_b"></div>' +
        '</div>';
      $.each(drupalSettings.synapse, function (index, value) {
        var mapSet = value;
        $(mapSet.attach).before(pos);
        var map = new ymaps.Map('map', {
          center: [mapSet.longitude, mapSet.latitude],
          zoom: mapSet.zoom,
          controls: ['zoomControl', 'fullscreenControl']
        });

        map.behaviors.disable('scrollZoom');

        var iconHref = drupalSettings.synmap.icon;
        if (drupalSettings.synmap.iconreplace) {
          iconHref = drupalSettings.synmap.iconreplace;
        }

        var icon = '<svg viewBox="0 0 320 403" width="32" height="49"><use href="#placemark-icon"/></svg>';
        var companyPlacemark = new ymaps.Placemark(
          [mapSet.longitude, mapSet.latitude], {
            balloonContent: mapSet.name
          }, {
            iconLayout: 'default#image',
            iconImageHref: iconHref,
            iconImageSize: [43, 57],
            iconImageOffset: [-21.5, -57]
            //iconLayout: ymaps.templateLayoutFactory.createClass(icon),
            //iconImageSize: [32, 49],
            //iconImageOffset: [-16, -49]
          }
        );
        map.geoObjects.add(companyPlacemark);
        // Position examle.
        if (false) {
          var position = map.getGlobalPixelCenter();
          map.setGlobalPixelCenter([position[0] - mapSet.offset_y, position[1] - mapSet.offset_x]);
        }
      });
    }
  });
})(this.jQuery);
