/**
 * @file
 * Author: Synpase-studio.
 */

(function ($) {
  $(document).ready(function () {
    ymaps.ready(ymapsInit);

    function ymapsInit() {
      var mapSet = drupalSettings.synapse;
      // Debug: console.log(mapSet);
      $('#edit-geo').after('<div id="map-picker" style="min-height:300px"></div>');

      var map = new ymaps.Map('map-picker', {
        center: [mapSet.longitude, mapSet.latitude],
        zoom: mapSet.zoom,
        controls: ['zoomControl', 'fullscreenControl']
      });
      var searchControl = new ymaps.control.SearchControl({
        options: {
          provider: 'yandex#search'
        }
      });
      map.controls.add(searchControl);
      map.behaviors.disable('scrollZoom');

      var companyPlacemark = new ymaps.GeoObject({
        geometry: {
          type: 'Point',
          coordinates: [mapSet.longitude, mapSet.latitude]
        },
        properties: {
          iconContent: mapSet.name,
          hintContent: 'Я тащусь'
        }
      }, {
        preset: 'islands#blackStretchyIcon',
        draggable: true
      });

      map.geoObjects.add(companyPlacemark);
      var position = map.getGlobalPixelCenter();
      map.setGlobalPixelCenter([position[0], position[1]]);

      companyPlacemark.events.add('dragend', function (e) {
        var coords = companyPlacemark.geometry.getCoordinates();
        console.log(coords);
        // Пишем X и Y в инпуты.
        $(mapSet.editlatitude).attr('value', coords[1]);
        $(mapSet.editlongitude).attr('value', coords[0]);
      });
      map.events.add('click', function (e) {
        map.geoObjects.remove(companyPlacemark);
        var companyPlacemark = new ymaps.GeoObject({
          geometry: {
            type: 'Point',
            coordinates: e.get('coords')
          },
          properties: {
            iconContent: mapSet.name,
            hintContent: 'Я тащусь'
          }
        }, {
          preset: 'islands#blackStretchyIcon',
          draggable: true
        });

        map.geoObjects.add(companyPlacemark);

        var coords = e.get('coords');
        console.log(coords[0]);
        // Пишем X и Y в инпуты.
        $(mapSet.editlatitude).attr('value', coords[1]);
        $(mapSet.editlongitude).attr('value', coords[0]);
      });
    }
  });
})(this.jQuery);
